/****** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is XpcomViewer code.
 *
 * The Initial Developer of the Original Code is
 * Ondrej Donek.
 * Portions created by Initial Developer are Copyright (C) 2005-2006
 * Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  - Ondrej Donek, <ondrejd@gmail.com>, original author
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the LGPL or the GPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 ****** END LICENSE BLOCK *****/


var gXpcomClassesCount = 0;


/**
 * Implementation of main XpcomViewer tree for displaying Components.classes
 * @see global.js
 */
var gTreeClassesPrototype = new newTreeView ();

gTreeClassesPrototype.toggleOpenState = function (aRow) {
  if (this.isContainer (aRow)) {
    if (this.isContainerOpen (aRow)) {
      // close container
      var delCount = 0;
      var level = this.getLevel (aRow);

      for (var i=aRow+1; i<gXpcomTreeView.length; i++) {
      if (this.getLevel(i) > level) delCount++;
      else break;
    }

      if (delCount > 0) {
        gXpcomTreeView.splice (aRow + 1, delCount);
        this.treeBox.rowCountChanged (aRow + 1, delCount);
      }

      gXpcomTreeView [aRow].mIsContainerOpen = false;
    } else {
      // open container
      if (gXpcomTreeView [aRow].mType == "class") {
	      var cl = Components.classes [gXpcomTreeView [aRow].mNameCol];
        cl = cl.createInstance ();

        for (var ifc in Components.interfaces) {
          try {
            var iface = cl.QueryInterface (Components.interfaces [ifc]);
            if (iface) {
              var ifaceName = ifc;
              var ifaceValue = Components.interfaces [ifc].number;
              var ifaceType = "interface";
		          var ifaceItem = new newTreeItem (ifc, ifaceValue, "interface", 1, false);

		          if (ifc != "nsISupports" && ifc != "IDispatch") {
		            ifaceItem.mIsContainer = true;
		          	ifaceItem.mIsContainerEmpty = false;
		          } else {
		            ifaceItem.mValueCol = "";
		          }

		          gXpcomTreeView.splice (aRow + 1, -1, ifaceItem);
		          this.treeBox.rowCountChanged (aRow+1, 1);
	        	}
          } catch (e) {}
        }

	      // XXX Use nsIClassInfo
        /* try {
          var info = cl.QueryInterface (Components.interfaces.nsIClassInfo);

          if (info) {
			      var ifaceItem = new newTreeItem ("nsIClassInfo", "", "interface", 1, true);

						ifaceItem.mIsContainerEmpty = false;
		        gXpcomTreeView.splice (aRow + 1, -1, ifaceItem);
		        this.treeBox.rowCountChanged (aRow+1, 1);
			    }
        } catch (e) {
          Components.utils.reportError ();
        } */

	      gXpcomTreeView[aRow].mIsContainerOpen = true;
      } else if (gXpcomTreeView [aRow].mType == "interface" &&
                 gXpcomTreeView [aRow].mNameCol != "nsISupports") {
        var clName = gXpcomTreeView [this.getParentIndex (aRow)].mNameCol;
        var ifaceName = gXpcomTreeView [aRow].mNameCol;

        try {
          var inst = Components.classes [clName].
              createInstance (Components.interfaces [ifaceName]);
        } catch (e) {
          try {
          	var inst = Components.classes [clName].
          	    getService (Components.interfaces [ifaceName]);
          } catch (e) { }
	      }

        if (inst) {
          var origIndex = aRow;

				  for (var ifaceProperty in inst) {
				    var ifaceProp = inst [ifaceProperty];
				    var ifacePropType = ((new String (ifaceProp)).indexOf ("function") != -1)
				        ? "method" : "variable";
				    var ifacePropValue = (ifacePropType == "method") ? "" : ifaceProp;
				    var ifacePropTreeItem = new newTreeItem (ifaceProperty, ifacePropValue,
				        ifacePropType, 2, false);

				    gXpcomTreeView.splice (origIndex + 1, -1, ifacePropTreeItem);
            this.treeBox.rowCountChanged (origIndex + 1, 1);
				  }

				  gXpcomTreeView[origIndex].mIsContainerOpen = true;
        }
      }
    }
  }
};
